zoukankan      html  css  js  c++  java
  • hdu 1028 Ignatius and the Princess III

    Ignatius and the Princess III

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 16918    Accepted Submission(s): 11907


    Problem Description
    "Well, it seems the first problem is too easy. I will let you know how foolish you are later." feng5166 says.

    "The second problem is, given an positive integer N, we define an equation like this:
      N=a[1]+a[2]+a[3]+...+a[m];
      a[i]>0,1<=m<=N;
    My question is how many different equations you can find for a given N.
    For example, assume N is 4, we can find:
      4 = 4;
      4 = 3 + 1;
      4 = 2 + 2;
      4 = 2 + 1 + 1;
      4 = 1 + 1 + 1 + 1;
    so the result is 5 when N is 4. Note that "4 = 3 + 1" and "4 = 1 + 3" is the same in this problem. Now, you do it!"
     
    Input
    The input contains several test cases. Each test case contains a positive integer N(1<=N<=120) which is mentioned above. The input is terminated by the end of file.
     
    Output
    For each test case, you have to output a line contains an integer P which indicate the different equations you have found.
     
    Sample Input
    4
    10
    20
     
    Sample Output
    5
    42
    627
     
    Author
    Ignatius.L
     
    Recommend
    We have carefully selected several similar problems for you:  1171 1085 1398 2152 1709 
     
    整数划分问题,和我前面写的一篇博客是一样的,参考:http://www.cnblogs.com/pshw/p/4838898.html
    不过此题数据比较大,直接递归计算会导致超时,因此需要使用母函数的思想。其实我也不知道啥叫母函数。。。只是用dp将数据保存起来。
     
    题意:整数划分问题是将一个正整数n拆成一组数连加并等于n的形式,且这组数中的最大加数不大于n。
     
    附上代码:
     
     1 #include <iostream>
     2 #include <cstdio>
     3 #include <cstring>
     4 using namespace std;
     5 int main()
     6 {
     7     int n,i,j,m;
     8     int dp[125][125];
     9     memset(dp,0,sizeof(dp));
    10     dp[1][1]=1;
    11     for(i=1; i<=120; i++)
    12     {
    13         dp[i][1]=1;
    14         dp[1][i]=1;
    15     }
    16     for(i=2; i<=120; i++)  //规律可见推荐的博客~
    17     {
    18         for(j=2; j<=120; j++)
    19         {
    20             if(j>i)
    21                 dp[i][j]=dp[i][i];
    22             else if(i==j)
    23                 dp[i][j]=dp[i][j-1]+1;
    24             else
    25                 dp[i][j]=dp[i][j-1]+dp[i-j][j];
    26         }
    27     }
    28     while(~scanf("%d",&n))
    29     {
    30         printf("%d
    ",dp[n][n]);
    31     }
    32     return 0;
    33 }
  • 相关阅读:
    Java学习8.31
    Java学习8.30
    Java学习8.29
    Java学习8.28
    Java学习8.27
    Java学习8.26
    242. Valid Anagram 有效的字符串
    680. Valid Palindrome II 对称字符串-可删一个字母版本
    151. Reverse Words in a String翻转一句话中的单词
    155. Min Stack 155.最小栈
  • 原文地址:https://www.cnblogs.com/pshw/p/5242371.html
Copyright © 2011-2022 走看看